
#include "main.h"
#include "ttype_select.h"
#include "map.h"

TTypeSelectDialog::TTypeSelectDialog(int init)
:	wxDialog(NULL, -1, "Select Thing Type", wxDefaultPosition, wxDefaultSize)
{
	wxBoxSizer *m_vbox = new wxBoxSizer(wxVERTICAL);
	SetSizer(m_vbox);

	tree = new wxTreeCtrl(this, SD_TREE, wxDefaultPosition, wxSize(300, 300), wxTR_DEFAULT_STYLE|wxTR_HIDE_ROOT);
	m_vbox->Add(tree, 1, wxEXPAND|wxALL, 4);

	selected_val = init;
	populate_tree_ttypes(tree, init);

	m_vbox->Add(CreateButtonSizer(wxOK|wxCANCEL), 0, wxEXPAND|wxALL, 4);

	Layout();
	SetBestFittingSize();
}

TTypeSelectDialog::~TTypeSelectDialog()
{
}

BEGIN_EVENT_TABLE(TTypeSelectDialog, wxDialog)
	EVT_TREE_SEL_CHANGING(SD_TREE, TTypeSelectDialog::tree_selection_changed)
	EVT_TREE_ITEM_ACTIVATED(SD_TREE, TTypeSelectDialog::tree_item_activated)
END_EVENT_TABLE()

void TTypeSelectDialog::tree_selection_changed(wxTreeEvent &event)
{
	if (tree->ItemHasChildren(event.GetItem()))
		selected_val = -1;
	else
	{
		wxString spec = tree->GetItemText(event.GetItem());

		if (spec != "")
			sscanf(spec, "%d", &selected_val);
	}
}

void TTypeSelectDialog::tree_item_activated(wxTreeEvent &event)
{
	if (!tree->ItemHasChildren(event.GetItem()))
		EndModal(wxID_OK);
}
